#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    int sz = find_minmax({}, min, max);

    CHECK(sz == 0);
}

TEST_CASE("single element vector") {
    double min = 0;
    double max = 0;
    find_minmax({5}, min, max);
    CHECK(min == 5);
    CHECK(max == 5);
}

TEST_CASE("negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-3, -1, -5}, min, max);
    CHECK(min == -5);
    CHECK(max == -1);
}

TEST_CASE("identical elements") {
    double min = 0;
    double max = 0;
    find_minmax({7, 7, 7}, min, max);
    CHECK(min == 7);
    CHECK(max == 7);
}

TEST_CASE("mixed positive and negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-2, 3, 0, -5, 4}, min, max);
    CHECK(min == -5);
    CHECK(max == 4);
}
